package com.engine.organization.mapper.post;


import com.engine.organization.entity.postion.po.PostInfoPO;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/13
 * @Version V1.0
 **/
public interface PostInfoMapper {

    /**
     * 根据No查询职务信息
     *
     * @param postInfoNo
     * @return
     */
    List<PostInfoPO> listByNo(@Param("postInfoNo") String postInfoNo);

    PostInfoPO getPostInfoByNameAndPostId(@Param("postInfoName") String postInfoName, @Param("postId") Long postId);

    /**
     * 获取职务信息根据ID
     *
     * @param id
     * @return
     */
    PostInfoPO getPostInfoByID(@Param("id") long id);

    /**
     * 根据ID查询职务信息列表
     *
     * @param ids
     * @return
     */
    @MapKey("id")
    List<Map<String, Object>> listPostInfosByIds(@Param("ids") Collection<Long> ids);

    /**
     * 插入职务信息
     *
     * @param postInfoPO
     * @return
     */
    int insertIgnoreNull(PostInfoPO postInfoPO);

    /**
     * 修改，修改所有字段
     *
     * @param postInfoPO
     * @return
     */
    int updatePostInfo(PostInfoPO postInfoPO);

    /**
     * 更新禁用标记
     *
     * @param postInfoPO
     * @return
     */
    int updateForbiddenTagById(PostInfoPO postInfoPO);

    /**
     * 批量删除职务信息方案
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);


    List<PostInfoPO> getPostInfosByIds(@Param("ids") Collection<Long> ids);

    /**
     * 查询所有被引用的ID
     *
     * @return
     */
    List<String> listUsedId();
}
